// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;
  var template = _ref.template;

  var injectAssert = function injectAssert(path, leadingComments) {
    var comment = leadingComments[0];
    if (comment.type === 'CommentBlock') {
      var functionDeclarationString = _jsdocToAssert.Attachment.FunctionDeclarationString(comment);
      var buildAssert = template(functionDeclarationString)();
      path.get("body").unshiftContainer("body", buildAssert);
    }
  };
  return {
    visitor: _defineProperty({
      // TODO: way?
      // ArrowFunctionExpression | VariableDeclaration
      // VariableDeclaration(path){
      //   if (maybeSkip(path)) {
      //     return;
      //   }
      //   const {node} = path;
      //   if (node.declarations) {
      //     node.declarations.forEach(declaration => {
      //       const declarator = t.variableDeclarator(declaration.id, declaration.init);
      //       console.log(declarator.unshiftContainer);
      //       injectAssert(declarator, node.leadingComments);
      //     });
      //   }
      // },

      ExportNamedDeclaration: function ExportNamedDeclaration(path) {
        if (maybeSkip(path)) {
          return;
        }
        var node = path.node;

        if (node.declaration) {
          var declaration = path.get("declaration");
          if (declaration.isVariableDeclaration()) {
            return;
          }
          injectAssert(declaration, node.leadingComments);
        }
      }
    }, "ObjectMethod|ClassMethod|FunctionDeclaration", function ObjectMethodClassMethodFunctionDeclaration(path) {
      if (maybeSkip(path)) {
        return;
      }
      var node = path.node;

      injectAssert(path, node.leadingComments);
    })
  };
};

var _jsdocToAssert = require("jsdoc-to-assert");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function maybeSkip(path) {
  var node = path.node;

  if (node.leadingComments != null && node.leadingComments.length > 0) {
    return false;
  }
  return true;
}
module.exports = exports['default'];
//# sourceMappingURL=index.js.map